"""
 functions to match a bunch of fragment descriptors from a file

No user-servicable parts inside.  ;-)

"""
from __future__ import annotations
import os as os
from rdkit import Chem
from rdkit import RDConfig
__all__ = ['Chem', 'RDConfig', 'defaultPatternFileName', 'fn', 'fns', 'name', 'os']
def _CountMatches(mol, patt, unique = True):
    ...
def _LoadPatterns(fileName = None):
    ...
defaultPatternFileName: str = '/project/build/temp.linux-aarch64-cpython-312/rdkit_install/share/RDKit/Data/FragmentDescriptors.csv'
fn = None
fns: list  # value = [('fr_C_O', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d9239c0>), ('fr_C_O_noCOO', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d923a60>), ('fr_Al_OH', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d923b00>), ('fr_Ar_OH', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d923ba0>), ('fr_methoxy', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d923c40>), ('fr_oxime', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d923ce0>), ('fr_ester', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d923d80>), ('fr_Al_COO', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d923e20>), ('fr_Ar_COO', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d923ec0>), ('fr_COO', <function _LoadPatterns.<locals>.<lambda> at 0xffff7d923f60>), ('fr_COO2', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404040>), ('fr_ketone', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4040e0>), ('fr_ether', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404180>), ('fr_phenol', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404220>), ('fr_aldehyde', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4042c0>), ('fr_quatN', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404360>), ('fr_NH2', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404400>), ('fr_NH1', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4044a0>), ('fr_NH0', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404540>), ('fr_Ar_N', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4045e0>), ('fr_Ar_NH', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404680>), ('fr_aniline', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404720>), ('fr_Imine', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4047c0>), ('fr_nitrile', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404860>), ('fr_hdrzine', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404900>), ('fr_hdrzone', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4049a0>), ('fr_nitroso', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404a40>), ('fr_N_O', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404ae0>), ('fr_nitro', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404b80>), ('fr_azo', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404c20>), ('fr_diazo', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404cc0>), ('fr_azide', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404d60>), ('fr_amide', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404e00>), ('fr_priamide', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404ea0>), ('fr_amidine', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404f40>), ('fr_guanido', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c404fe0>), ('fr_Nhpyrrole', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405080>), ('fr_imide', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405120>), ('fr_isocyan', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4051c0>), ('fr_isothiocyan', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405260>), ('fr_thiocyan', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405300>), ('fr_halogen', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4053a0>), ('fr_alkyl_halide', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405440>), ('fr_sulfide', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4054e0>), ('fr_SH', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405580>), ('fr_C_S', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405620>), ('fr_sulfone', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4056c0>), ('fr_sulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405760>), ('fr_prisulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405800>), ('fr_barbitur', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4058a0>), ('fr_urea', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405940>), ('fr_term_acetylene', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4059e0>), ('fr_imidazole', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405a80>), ('fr_furan', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405b20>), ('fr_thiophene', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405bc0>), ('fr_thiazole', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405c60>), ('fr_oxazole', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405d00>), ('fr_pyridine', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405da0>), ('fr_piperdine', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405e40>), ('fr_piperzine', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405ee0>), ('fr_morpholine', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c405f80>), ('fr_lactam', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406020>), ('fr_lactone', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4060c0>), ('fr_tetrazole', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406160>), ('fr_epoxide', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406200>), ('fr_unbrch_alkane', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4062a0>), ('fr_bicyclic', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406340>), ('fr_benzene', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4063e0>), ('fr_phos_acid', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406480>), ('fr_phos_ester', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406520>), ('fr_nitro_arom', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4065c0>), ('fr_nitro_arom_nonortho', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406660>), ('fr_dihydropyridine', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406700>), ('fr_phenol_noOrthoHbond', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4067a0>), ('fr_Al_OH_noTert', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406840>), ('fr_benzodiazepine', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c4068e0>), ('fr_para_hydroxylation', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406980>), ('fr_allylic_oxid', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406a20>), ('fr_aryl_methyl', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406ac0>), ('fr_Ndealkylation1', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406b60>), ('fr_Ndealkylation2', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406ca0>), ('fr_alkyl_carbamate', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406c00>), ('fr_ketone_Topliss', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406d40>), ('fr_ArN', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406de0>), ('fr_HOCCN', <function _LoadPatterns.<locals>.<lambda> at 0xffff7c406e80>)]
name: str = 'fr_HOCCN'
